﻿using BepInEx;
using HarmonyLib;
using System.Reflection;
using System.Collections.Concurrent;

namespace AFLDLevelToRpm
{
    [BepInPlugin(GUID, NAME, MOD_VERS)]
    [BepInDependency("Harb.DisableProgression")]
    public class Plugin : BaseUnityPlugin
    {
        public const string GUID = "5fcf1cfc-383c-4ee8-961a-868f560452d9";
        public const string NAME = "Levels to Rpm";
        public const string MOD_VERS = "1.0";
        public static ConcurrentDictionary<TowerType, float> base_rpms;
        private void Awake()
        {
            base_rpms = new ConcurrentDictionary<TowerType, float>();
            Harmony.CreateAndPatchAll(Assembly.GetExecutingAssembly());
        }
    }

    [HarmonyPatch(typeof(Tower), nameof(Tower.SetStats))]
    public class TowerSetStatsPatch
    {
        static void Prefix(ref Tower __instance)
        {
            int level = __instance.level;
            float adjusted_rpm = Plugin.base_rpms.GetOrAdd(__instance.towerType, __instance.rpm);
#if(DEBUG)
            UnityEngine.Debug.Log("Base rpm: " + adjusted_rpm.ToString());
#endif
            adjusted_rpm *= 1.0f + (.07f * level);
#if(DEBUG)
            UnityEngine.Debug.Log("Adjusted rpm: " + adjusted_rpm.ToString());
#endif
            __instance.rpm = adjusted_rpm;
        }
    }
}
